#!/bin/sh

# This is a convenience script that works around some limitations in
# the current dbus-binding-tool. It will probably become unnecessary
# in the future.

set -e

test -n "$1"
test -n "$2"

IF_NAME=$1
IF_FILE=$2
IF_UNAME=`echo $IF_FILE | sed s/-/_/g`
IF_BASE=`echo $IF_NAME | cut -f1 -d.`

strip_dbus_introspection ()
{
	# strip the DBus introspection definition
	perl -pe '$/=undef; s/<interface name.*DBus.*>(.|\n)*?<\/interface>//;'
}

strip_definition ()
{
	perl -pe '$/=undef; s/<interface name.*'"$1"'.>(.|\n)*?<\/interface>//;'
}

add_annotation ()
{
	iface="$1"
	uname="$2"
	ANT="<annotation name=\"org.freedesktop.DBus.GLib.ClientCSymbol\" value=\"$uname\"\/>"
	sed -e s/org.freedesktop.Telepathy."$iface".*$/\&\\n"    $ANT"/
}

#echo "$IF_NAME" -- "$IF_UNAME" -- "$IF_BASE -- $IF_FILE" >&2

if [ "$IF_BASE" != "$IF_NAME" ]; then
	# strip the redefinition of the channel base interface

	strip_dbus_introspection | \
	strip_definition "$IF_BASE" | \
	add_annotation "$IF_BASE" "$IF_UNAME"
else
	strip_dbus_introspection | \
	add_annotation "$IF_BASE" "$IF_UNAME"
fi

